process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean error;
     )
   (| (| OK := a/=0.0
       | (| SecondDegree_ABS(a,b,c) |)/ C_bb
                                      / stable
                                      / C_err
                                      / C_y
                                      / C_x
       | (| FirstDegree_ABS(not OK,b,c) |)/ C_cc1
                                          / C_error
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | error := (when err1) default err2
             |)
          | x1 := u
          |) where real u, a1, a2;
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21, OK |)
   where 
   boolean err2, err, C_x, C_y, C_err, stable, C_OK, OK, C_bb, C_error, C_cc1;
   process FirstDegree_ABS =
        ( ? boolean Compute;
            real b, c;
          ! real x;
            boolean err2, C_bb, C_error;
        )
        spec (| (| Compute --> x
                 | b --> x
                 | c --> x
                 | Compute --> err2
                 | b --> err2
                 | c --> err2
                 |)
              | (| Compute ^= b ^= c
                 | when Compute ^= C_bb ^= C_error
                 | when C_bb ^= x
                 | when C_error ^= err2
                 |)
              |)
      pragmas 
         Black_Box "FirstDegree"
      end pragmas
      external "C"
   ; 
   process SecondDegree_ABS =
        ( ? real a, b, c;
          ! boolean err;
            real x21, x2;
            boolean stable init true, C_y, C_bb, C_err, C_x;
        )
        spec (| (| a --> err
                 | b --> err
                 | c --> err
                 | a --> x21
                 | b --> x21
                 | c --> x21
                 | a --> x2
                 | b --> x2
                 | c --> x2
                 |)
              | (| stable ^= C_y ^= C_x
                 | when stable ^= a ^= b ^= c ^= C_bb
                 | when C_y ^= x2
                 | when C_bb ^= C_err
                 | when C_err ^= err
                 | when C_x ^= x21
                 |)
              |)
      pragmas 
         Black_Box "SecondDegree"
      end pragmas
      external "C"
   ; 
   real x21, x;
   end
; 
