process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean error;
     )
   (| (| OK := a/=0.0
       | (| SecondDegree_ABS(a,b,c) |)/ C_y
                                      / stable
                                      / C_err
                                      / C_bb
                                      / C_x
       | FirstDegree(not OK,b,c)
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | error := (when err1) default err2
             |)
          | x1 := u
          |) where real u, a1, a2;
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21, OK |)
   where 
   constant real cst_epsilon = 0.0001;
   boolean err2, err, C_x, C_bb, C_err, stable, C_OK, OK, C_y, C_error, C_cc1;
   process FirstDegree =
        ( ? boolean Compute;
            real b;
            real c;
          ! real x;
            boolean err2;
        )
      (| (| (| (| c := cc_2
                | b := bb_1
                | (| bb := b when (b/=0.0)
                   | cc := c when (b/=0.0)
                   | x := -(cc/bb)
                   |)
                |)/ cc, bb |) where real b, c; end
          | (| c := cc_2
             | b := bb_1
             | error := (c/=0.0) when (b=0.0)
             | err2 := error
             |) where boolean error;
                      real b, c; end
          | (| (| bb := b when Compute
                | cc := c when Compute
                |)
             | bb_1 := bb
             | cc_2 := cc
             |) where real bb, cc; end
          |)/ cc_2, bb_1 |)
      where 
      real bb, cc, bb_1, cc_2;
      end
   ; 

process SecondDegree_ABS=
     ( ? real a, b, c;
       ! boolean err;
         real x21, x2;
         boolean stable init true, C_y, C_bb, C_err, C_x;
     )
   pragmas 
      Grey_Box "SecondDegree"
   end pragmas
   (| (| Tick := true
       | when Tick ^= stable ^= C_y ^= C_x
       | when stable ^= a ^= b ^= c ^= C_bb
       | when C_y ^= x2
       | when C_bb ^= C_err
       | when C_err ^= err
       | when C_x ^= x21
       |)
    | (| nlabel :: (err,x21,x2,C_y,C_err,C_x) := SecondDegree_Cluster_1()
       | nlabel ^= when Tick
       |)
    | (| nlabel_276 :: SecondDegree_Cluster_2(b)
       | nlabel_276 ^= when stable
       |)
    | (| nlabel_277 :: SecondDegree_Cluster_3(c)
       | nlabel_277 ^= when stable
       |)
    | (| nlabel_278 :: C_bb := SecondDegree_Cluster_4(a)
       | nlabel_278 ^= when Tick
       |)
    | (| nlabel_302 :: stable := SecondDegree_Cluster_delays()
       | nlabel_302 ^= when Tick
       |)
    | (| c --> nlabel
       | b --> nlabel
       | a --> nlabel
       | nlabel_276 --> nlabel
       | b --> nlabel_276
       | nlabel_277 --> nlabel
       | c --> nlabel_277
       | nlabel_278 --> nlabel_277
       | nlabel_278 --> nlabel_276
       | nlabel_278 --> nlabel
       | a --> nlabel_278
       | nlabel_278 --> nlabel_302
       | nlabel_277 --> nlabel_302
       | nlabel_276 --> nlabel_302
       | nlabel --> nlabel_302
       |)
    |)
   where 
   boolean Tick;
   label nlabel, nlabel_276, nlabel_277, nlabel_278, nlabel_302; 
   action SecondDegree_Cluster_1 =
        ( ! boolean err;
            real x21;
            real x2;
            boolean C_y;
            boolean C_err;
            boolean C_x;
        )
      pragmas 
         Black_Box ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_1%; 
   action SecondDegree_Cluster_2 =
        ( ? real b;
        )
      pragmas 
         Black_Box ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_2%; 
   action SecondDegree_Cluster_3 =
        ( ? real c;
        )
      pragmas 
         Black_Box ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_3%; 
   action SecondDegree_Cluster_4 =
        ( ? real a;
          ! boolean C_bb;
        )
      pragmas 
         Black_Box ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_4%; 
   action SecondDegree_Cluster_delays =
        ( ! boolean stable init true;
        )
      pragmas 
         DelayCluster ""
         Black_Box ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_delays%; 
   end
%SecondDegree_ABSTRACT%; 
   real x21, x;
   end
; 
