#!/bin/tcsh


setenv XSIGNAL "$Signal_bin/signal"
unalias make


echo " *******************************************************************************************************************"
echo "                                            Q1  Profiling "

$XSIGNAL Q1.SIG -profiling -bdc+ -crew
#          Production de 
#              Q1_Simu_bDC_TRA.SIG    --> Q1_Simu.SIG
#
#              M_Q1_COST.SIG

echo " *******************************************************************************************************************"
echo "                                     ABSTRACTION OF Q1COSTP1 WITH CLUSTERS  (GREY BOXES) "


$XSIGNAL -tra -crew -clu -spec -c Q1COSTQ1.SIG
#         (-spec -clu) 
#          --> Production du code C (separe en lignees) 
#          --> Abstraction "Boite Grise" : Q1COSTQ1_ABSTRACT.SIG 

echo ""
echo "       make separate -f Makefile_Q1COSTQ1 "

setenv HERE $PWD
cd      Q1COSTQ1
       make separate -f Makefile_Q1COSTQ1
cd $HERE
#                  Production de Q1COSTQ1.o 
#******************************************************************************************--------

#Production de Q2COSTQ2.SIG 

echo " *******************************************************************************************************************"
echo "                                             Q2  Profiling "

          $XSIGNAL Q2.SIG -profiling

echo ""
echo " *******************************************************************************************************************"
echo "                                    ABSTRACTION OF Q2COSTP2 WITH CLUSTERS  (GREY BOX) "

         $XSIGNAL -tra -crew -clu -spec -c Q2COSTQ2.SIG
#         (-spec -clu) 
#          --> Production du code C (separe en lignees) 
#          --> Abstraction "Boite Grise" : Q2COSTQ2_ABSTRACT.SIG 
             
echo ""
echo "             make separate -f Makefile_Q2COSTQ2 "
cd Q2COSTQ2
       make separate -f Makefile_Q2COSTQ2
cd $HERE
#                  Production de Q2COSTQ2.o 

#------------------
#
#   Q1COSTQ1Q2COSTQ2  = (|  Abs(Q1COSTQ1)  | Abs (Q2COSTQ2) |)     (Abs : abstraction boite Grise)

echo " *******************************************************************************************************************"
echo "                                      $XSIGNAL -tra -c Q1COSTQ1Q2COSTQ2.SIG   "
     $XSIGNAL -tra -c Q1COSTQ1Q2COSTQ2.SIG


# --> Production de l'executable.
#     produit par signalLink Q1Q2COSTQ1COSTQ2 Q1COSTQ1 Q2COSTQ2)     

echo "                                      linking  "

\cp Q1COSTQ1/Q1COSTQ1_body_separate.o Q1COSTQ1Q2COSTQ2/.
\cp Q1COSTQ1/Q1COSTQ1_body_separate.h Q1COSTQ1Q2COSTQ2/.

\cp Q2COSTQ2/Q2COSTQ2_body_separate.o Q1COSTQ1Q2COSTQ2/.
\cp Q2COSTQ2/Q2COSTQ2_body_separate.h Q1COSTQ1Q2COSTQ2/.

cd Q1COSTQ1Q2COSTQ2
     make -f link_Q1COSTQ1Q2COSTQ2
     Q1COSTQ1Q2COSTQ2 &
cd $HERE




